
;  GNU C 2.7.2 [AL 1.1, MM 40] RISC NEWS-OS compiled by CC

;  Cc1 defaults:
;  -mmemcpy

;  Cc1 arguments (-G value = 0, Cpu = 3000, ISA = 1):
;  -quiet -dumpbase -O2 -Wall -o

gcc2_compiled.:
__gnu_compiled_c:
	.global	ppu_grayscale_table
	.code
	.align	2
ppu_grayscale_table:
	.byte	21
	.byte	33
	.byte	37
	.byte	36
	.byte	32
	.byte	31
	.byte	32
	.byte	33
	.byte	33
	.byte	35
	.byte	35
	.byte	34
	.byte	34
	.byte	42
	.byte	41
	.byte	41
	.byte	9
	.byte	26
	.byte	27
	.byte	26
	.byte	23
	.byte	24
	.byte	26
	.byte	27
	.byte	23
	.byte	27
	.byte	28
	.byte	27
	.byte	23
	.byte	37
	.byte	41
	.byte	41
	.byte	0
	.byte	16
	.byte	16
	.byte	14
	.byte	18
	.byte	17
	.byte	15
	.byte	14
	.byte	11
	.byte	12
	.byte	16
	.byte	15
	.byte	13
	.byte	27
	.byte	40
	.byte	40
	.byte	0
	.byte	5
	.byte	6
	.byte	10
	.byte	9
	.byte	10
	.byte	6
	.byte	3
	.byte	3
	.byte	6
	.byte	8
	.byte	7
	.byte	5
	.byte	6
	.byte	39
	.byte	39
	.code
	.align	1
	.global	ppu_reset
ppu_reset:
;	.frame	%sp,8,$31		# vars= 0, regs= 2/0, args= 0, extra= 0
;	.mask	0x80010000,-4
;	.fmask	0x00000000,0
	pushn	%r0
	ld.w	%r0,%r12
	ext	ppu+0x0@h	; 	xld.w	%r12,ppu
	ext	ppu+0x0@m
	ld.w	%r12,ppu+0x0@l
	ld.w	%r13,0x0
	ext	0x0		; 	xld.w	%r14,0x00000034		; 52
	ld.w	%r14,0x34
	ext	memset@rm	; 	xcall	memset
	call	memset@rl
	and	%r0,0x1		; 	xand	%r0,%r0,0x00000001
	ext	ppu+0x8@ah	; 	xld.b	[ppu+8],%r0
	ext	ppu+0x8@al
	ld.b	[%r8],%r0
	popn	%r0
	ret
	.align	1
	.global	ppu_read
ppu_read:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ext	ppu+0x0@h	; 	xld.w	%r13,ppu
	ext	ppu+0x0@m
	ld.w	%r13,ppu+0x0@l
	and	%r12,0x7	; 	xand	%r12,%r12,0x00000007
	cmp	%r12,0x2	; 	xcmp	%r12,2
	jreq	__LX29		; 	xjreq	__L29
	cmp	%r12,0x7	; 	xcmp	%r12,7
	jreq	__LX30		; 	xjreq	__L30
	jp	__LX33		; 	xjp	__L33
__LX29:				; __L29:
	ext	ppu+0x2@ah	; 	xld.ub	%r12,[ppu+2]
	ext	ppu+0x2@al
	ld.ub	%r12,[%r8]
	jp	__LX28		; 	xjp	__L28
__LX30:				; __L30:
	ext	ppu+0x9@ah	; 	xld.ub	%r12,[ppu+9]
	ext	ppu+0x9@al
	ld.ub	%r12,[%r8]
	ext	ppu+0x6@ah	; 	xld.uh	%r11,[ppu+6]
	ext	ppu+0x6@al
	ld.uh	%r11,[%r8]
	ld.w	%r10,%r11
	ext	0xff		; 	xand	%r10,%r10,0x00003fff
	and	%r10,0x3f
	ext	ppu_vram+0x0@h	; 	xld.ub	%r10,[%r10+ppu_vram]
	ext	ppu_vram+0x0@m
	ld.w	%r9,ppu_vram+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	ext	ppu+0x9@ah	; 	xld.b	[ppu+9],%r10
	ext	ppu+0x9@al
	ld.b	[%r8],%r10
	ld.uh	%r11,%r11
	btst	[%r13],0x2	; 	xbtst	[%r13],0x2
	jreq	__LX31		; 	xjreq	__L31
	ext	0x20		; 	xadd	%r10,%r11,32
	add	%r10,%r11
	jp	__LX32		; 	xjp	__L32
__LX31:				; __L31:
	ext	0x1		; 	xadd	%r10,%r11,1
	add	%r10,%r11
__LX32:				; __L32:
	ext	0x6		; 	xld.h	[%r13+6],%r10
	ld.h	[%r13],%r10
	jp	__LX28		; 	xjp	__L28
__LX33:				; __L33:
	ld.w	%r12,0x0
__LX28:				; __L28:
	ld.w	%r10,%r12
	ret
	.align	1
	.global	ppu_write
ppu_write:
;	.frame	%sp,8,$31		# vars= 0, regs= 2/0, args= 0, extra= 0
;	.mask	0x80010000,-4
;	.fmask	0x00000000,0
	pushn	%r0
	ext	ppu+0x0@h	; 	xld.w	%r0,ppu
	ext	ppu+0x0@m
	ld.w	%r0,ppu+0x0@l
	ld.w	%r10,%r12
	and	%r10,0x7	; 	xand	%r10,%r10,0x00000007
	cmp	%r10,0x7	; 	xcmp	%r10,7
	jrugt	__L36		; 	xjrugt	__L36
	sll	%r10,0x2	; 	xsll	%r10,2
	ext	__L46+0x0@h	; 	xld.w	%r10,[%r10+__L46]
	ext	__L46+0x0@m
	ld.w	%r9,__L46+0x0@l
	add	%r9,%r10
	ld.w	%r10,[%r9]
	jp	%r10
	.code
	.align	2
__L46:
	.word	__L37
	.word	__L38
	.word	__L36
	.word	__L39
	.word	__L40
	.word	__L41
	.word	__L42
	.word	__L43
	.code
__L37:
	ld.b	[%r0],%r13	; 	xld.b	[%r0],%r13
	jp	__L36		; 	xjp	__L36
__L38:
	ext	0x1		; 	xld.b	[%r0+1],%r13
	ld.b	[%r0],%r13
	jp	__L36		; 	xjp	__L36
__L39:
	ext	0x3		; 	xld.b	[%r0+3],%r13
	ld.b	[%r0],%r13
	jp	__L36		; 	xjp	__L36
__L40:
	ext	0x3		; 	xld.ub	%r10,[%r0+3]
	ld.ub	%r10,[%r0]
	ext	0x1		; 	xadd	%r11,%r10,1
	add	%r11,%r10
	ext	0x3		; 	xld.b	[%r0+3],%r11
	ld.b	[%r0],%r11
	ld.ub	%r10,%r10
	ext	ppu_sprram+0x0@h	; 	xld.b	[%r10+ppu_sprram],%r13
	ext	ppu_sprram+0x0@m
	ld.w	%r9,ppu_sprram+0x0@l
	add	%r9,%r10
	ld.b	[%r9],%r13
	jp	__L36		; 	xjp	__L36
__L41:
	ext	0x4		; 	xld.uh	%r10,[%r0+4]
	ld.uh	%r10,[%r0]
	sll	%r10,0x8	; 	xsll	%r10,8
	or	%r10,%r13
	ext	0x4		; 	xld.h	[%r0+4],%r10
	ld.h	[%r0],%r10
	jp	__L36		; 	xjp	__L36
__L42:
	ext	0x6		; 	xld.uh	%r10,[%r0+6]
	ld.uh	%r10,[%r0]
	sll	%r10,0x8	; 	xsll	%r10,8
	or	%r10,%r13
	jp	__LX45		; 	xjp	__L45
__L43:
	ext	0x6		; 	xld.uh	%r12,[%r0+6]
	ld.uh	%r12,[%r0]
	ext	0xff		; 	xand	%r12,%r12,0x00003fff
	and	%r12,0x3f
	ext	ppu_vram_write@rm	; 	xcall	ppu_vram_write
	call	ppu_vram_write@rl
	ext	0x6		; 	xld.uh	%r11,[%r0+6]
	ld.uh	%r11,[%r0]
	btst	[%r0],0x2	; 	xbtst	[%r0],0x2
	jreq	__LX44		; 	xjreq	__L44
	ext	0x20		; 	xadd	%r10,%r11,32
	add	%r10,%r11
	jp	__LX45		; 	xjp	__L45
__LX44:				; __L44:
	ext	0x1		; 	xadd	%r10,%r11,1
	add	%r10,%r11
__LX45:				; __L45:
	ext	0x6		; 	xld.h	[%r0+6],%r10
	ld.h	[%r0],%r10
__L36:
	popn	%r0
	ret
	.align	1
	.global	ppu_update
ppu_update:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	%r15,%r12
	ext	ppu+0x0@h	; 	xld.w	%r2,ppu
	ext	ppu+0x0@m
	ld.w	%r2,ppu+0x0@l
	ext	ppu_vram+0x0@h	; 	xld.w	%r12,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r12,ppu_vram+0x0@l
	ext	ppu+0x10@ah	; 	xld.h	%r3,[ppu+16]
	ext	ppu+0x10@al
	ld.h	%r3,[%r8]
	ext	0x3		; 	xld.w	%r11,0x000000ef		; 239
	ld.w	%r11,0x2f
	cmp	%r3,%r11
	jrgt	__LX49		; 	xjrgt	__L49
	ext	ppu_sprram+0x0@ah	; 	xld.ub	%r10,[ppu_sprram]
	ext	ppu_sprram+0x0@al
	ld.ub	%r10,[%r8]
	add	%r10,0x1	; 	xadd	%r10,%r10,1
	ld.ub	%r10,%r10
	cmp	%r10,%r11
	jrle	__LX50		; 	xjrle	__L50
	ld.b	%r10,%r10
__LX50:				; __L50:
	cmp	%r3,%r10
	jrge	__LX51		; 	xjrge	__L51
	ld.w	%r1,%r10
	ext	ppu+0x2@ah	; 	xbset	[ppu+2],0x6
	ext	ppu+0x2@al
	bset	[%r8],0x6
	jp	__LX52		; 	xjp	__L52
__LX51:				; __L51:
	ext	0x3		; 	xld.w	%r1,0x000000f0		; 240
	ld.w	%r1,0x30
	ext	ppu+0x2@ah	; 	xld.ub	%r10,[ppu+2]
	ext	ppu+0x2@al
	ld.ub	%r10,[%r8]
	ext	0x3		; 	xoor	%r10,%r10,0x000000c0
	or	%r10,0x0
	ext	ppu+0x2@ah	; 	xld.b	[ppu+2],%r10
	ext	ppu+0x2@al
	ld.b	[%r8],%r10
	ext	0x2		; 	xld.w	%r11,0x00000080		; 128
	ld.w	%r11,0x0
	ld.ub	%r10,[%r2]	; 	xld.ub	%r10,[%r2]
	ext	0x2		; 	xand	%r10,%r10,0x00000080
	and	%r10,0x0
	jreq	__LX52		; 	xjreq	__L52
	ld.w	%r10,%r11
	ext	ppu+0x8@ah	; 	xld.ub	%r4,[ppu+8]
	ext	ppu+0x8@al
	ld.ub	%r4,[%r8]
	or	%r10,%r4
	ext	ppu+0x8@ah	; 	xld.b	[ppu+8],%r10
	ext	ppu+0x8@al
	ld.b	[%r8],%r10
__LX52:				; __L52:
	cmp	%r15,0x0
	jreq	__LX54		; 	xjreq	__L54
	ext	0xc		; 	xld.w	[%r2+12],%r15
	ld.w	[%r2],%r15
	ext	0x12		; 	xld.h	[%r2+18],%r1
	ld.h	[%r2],%r1
	ext	0xfc		; 	xadd	%r12,%r12,16128
	add	%r12,0x0
	ext	0x14		; 	xadd	%r11,%r2,20
	add	%r11,%r2
	ext	0x0		; 	xld.w	%r0,0x00000020		; 32
	ld.w	%r0,0x20
	ext	0x0		; 	xld.w	%r13,0x0000003f		; 63
	ld.w	%r13,0x3f
__LX55:				; __L55:
	ld.ub	%r10,[%r12]	; 	xld.ub	%r10,[%r12]
	and	%r10,%r13
	add	%r12,0x1	; 	xadd	%r12,%r12,1
	ext	ppu_grayscale_table+0x0@h	; 	xld.ub	%r10,[%r10+ppu_grayscale_table]
	ext	ppu_grayscale_table+0x0@m
	ld.w	%r9,ppu_grayscale_table+0x0@l
	add	%r9,%r10
	ld.ub	%r10,[%r9]
	ld.b	[%r11],%r10	; 	xld.b	[%r11],%r10
	add	%r11,0x1	; 	xadd	%r11,%r11,1
	sub	%r0,0x1		; 	xsub	%r0,%r0,1
	jrne	__LX55		; 	xjrne	__L55
	ld.w	%r12,%r3
	sll	%r12,0x8	; 	xsll	%r12,8
	ext	0x14		; 	xld.ub	%r13,[%r2+20]
	ld.ub	%r13,[%r2]
	ld.w	%r14,%r1
	sub	%r14,%r3
	add	%r15,%r12
	ld.w	%r12,%r15
	sll	%r14,0x8	; 	xsll	%r14,8
	ext	memset@rm	; 	xcall	memset
	call	memset@rl
	ext	0x1		; 	xbtst	[%r2+1],0x4
	btst	[%r2],0x4
	jreq	__LX59		; 	xjreq	__L59
	ld.w	%r12,0x1	; 	xld.w	%r12,0x00000001		; 1
	ext	ppu_draw_sprite@rm	; 	xcall	ppu_draw_sprite
	call	ppu_draw_sprite@rl
__LX59:				; __L59:
	ext	0x1		; 	xbtst	[%r2+1],0x3
	btst	[%r2],0x3
	jreq	__LX60		; 	xjreq	__L60
	call	ppu_draw_bg	; 	xcall	ppu_draw_bg
__LX60:				; __L60:
	ext	0x1		; 	xbtst	[%r2+1],0x4
	btst	[%r2],0x4
	jreq	__LX54		; 	xjreq	__L54
	ld.w	%r12,%r0
	ext	ppu_draw_sprite@rm	; 	xcall	ppu_draw_sprite
	call	ppu_draw_sprite@rl
__LX54:				; __L54:
	ext	0x10		; 	xld.h	[%r2+16],%r1
	ld.h	[%r2],%r1
	jp	__LX62		; 	xjp	__L62
__LX49:				; __L49:
	ext	0x4		; 	xld.w	%r1,0x00000106		; 262
	ld.w	%r1,0x6
	ext	ppu+0x2@ah	; 	xld.ub	%r10,[ppu+2]
	ext	ppu+0x2@al
	ld.ub	%r10,[%r8]
	ext	0x0		; 	xand	%r10,%r10,0x0000003f
	and	%r10,0x3f
	ext	ppu+0x2@ah	; 	xld.b	[ppu+2],%r10
	ext	ppu+0x2@al
	ld.b	[%r8],%r10
	ld.w	%r4,0x0
	ext	ppu+0x10@ah	; 	xld.h	[ppu+16],%r4
	ext	ppu+0x10@al
	ld.h	[%r8],%r4
__LX62:				; __L62:
	ld.w	%r11,%r1
	sub	%r11,%r3
	ext	0x3		; 	xld.w	%r10,0x000000e4		; 228
	ld.w	%r10,0x24
	mlt.w	%r11,%r10
	ld.w	%r10,%alr
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	ppu_reduce
ppu_reduce:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r7,0x8		; 	xld.w	%r7,0x00000008		; 8
__LX64:				; __L64:
	ld.w	%r5,0x3		; 	xld.w	%r5,0x00000003		; 3
	ld.w	%r6,0xb		; 	xld.w	%r6,0x0000000b		; 11
__LX67:				; __L67:
	ext	0x1		; 	xld.w	%r4,0x00000040		; 64
	ld.w	%r4,0x0
	ext	0x100		; 	xadd	%r15,%r13,256
	add	%r15,%r13
__LX70:				; __L70:
	ld.w	%r10,[%r13]	; 	xld.w	%r10,[%r13]
	ld.w	%r11,[%r15]	; 	xld.w	%r11,[%r15]
	add	%r10,%r11
	ext	0x100		; 	xld.w	%r11,[%r15+256]
	ld.w	%r11,[%r15]
	add	%r10,%r11
	ld.ub	%r14,%r10
	srl	%r10,0x8	; 	xsrl	%r10,8
	ld.ub	%r11,%r10
	add	%r14,%r11
	ld.w	%r11,%r14
	srl	%r11,0x4	; 	xsrl	%r11,4
	ld.b	[%r12],%r11	; 	xld.b	[%r12],%r11
	add	%r12,0x1	; 	xadd	%r12,%r12,1
	srl	%r10,0x8	; 	xsrl	%r10,8
	ld.ub	%r14,%r10
	srl	%r10,0x8	; 	xsrl	%r10,8
	ld.ub	%r10,%r10
	add	%r14,%r10
	ld.w	%r10,%r14
	srl	%r10,0x4	; 	xsrl	%r10,4
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	add	%r12,0x1	; 	xadd	%r12,%r12,1
	add	%r15,0x4	; 	xadd	%r15,%r15,4
	add	%r13,0x4	; 	xadd	%r13,%r13,4
	sub	%r4,0x1		; 	xsub	%r4,%r4,1
	jrne	__LX70		; 	xjrne	__L70
	sub	%r5,0x1		; 	xsub	%r5,%r5,1
	jreq	__LX74		; 	xjreq	__L74
	ext	0x8		; 	xadd	%r13,%r13,512
	add	%r13,0x0
	jp	__LX69		; 	xjp	__L69
__LX74:				; __L74:
	ext	0x4		; 	xadd	%r13,%r13,256
	add	%r13,0x0
	ld.w	%r5,0x3		; 	xld.w	%r5,0x00000003		; 3
__LX69:				; __L69:
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	jrne	__LX67		; 	xjrne	__L67
	sub	%r7,0x1		; 	xsub	%r7,%r7,1
	jrne	__LX64		; 	xjrne	__L64
	ret
	.align	1
	.global	ppu_vram_write
ppu_vram_write:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ext	ppu_vram+0x0@h	; 	xld.w	%r11,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r11,ppu_vram+0x0@l
	ext	0x7f		; 	xcmp	%r12,8191
	cmp	%r12,0x3f
	jrle	__LX80		; 	xjrle	__L80
	ext	0xbf		; 	xcmp	%r12,12287
	cmp	%r12,0x3f
	jrgt	__LX81		; 	xjrgt	__L81
	ext	ppu+0x8@ah	; 	xld.ub	%r10,[ppu+8]
	ext	ppu+0x8@al
	ld.ub	%r10,[%r8]
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	jreq	__LX82		; 	xjreq	__L82
	ld.w	%r10,%r12
	ext	0x1fdf		; 	xand	%r10,%r10,0xfffff7ff
	and	%r10,0x3f
	add	%r10,%r11
	ld.b	[%r10],%r13	; 	xld.b	[%r10],%r13
	ld.w	%r10,%r12
	ext	0x20		; 	xoor	%r10,%r10,0x00000800
	or	%r10,0x0
	jp	__LX85		; 	xjp	__L85
__LX82:				; __L82:
	ld.w	%r10,%r12
	ext	0x1fef		; 	xand	%r10,%r10,0xfffffbff
	and	%r10,0x3f
	add	%r10,%r11
	ld.b	[%r10],%r13	; 	xld.b	[%r10],%r13
	ld.w	%r10,%r12
	ext	0x10		; 	xoor	%r10,%r10,0x00000400
	or	%r10,0x0
	jp	__LX85		; 	xjp	__L85
__LX81:				; __L81:
	ld.w	%r10,%r12
__LX85:				; __L85:
	add	%r10,%r11
	ld.b	[%r10],%r13	; 	xld.b	[%r10],%r13
__LX80:				; __L80:
	ret
	.align	1
	.global	ppu_draw_bg
ppu_draw_bg:
;	.frame	%sp,52,$31		# vars= 32, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x8		; 	xsub	%sp,%sp,32
	ext	ppu_vram+0x0@h	; 	xld.w	%r7,ppu_vram
	ext	ppu_vram+0x0@m
	ld.w	%r7,ppu_vram+0x0@l
	ext	ppu+0x10@ah	; 	xld.h	%r6,[ppu+16]
	ext	ppu+0x10@al
	ld.h	%r6,[%r8]
	ld.w	[%sp+0x0],%r6	; 	xld.w	[%sp],%r6
	ext	ppu+0x12@ah	; 	xld.h	%r6,[ppu+18]
	ext	ppu+0x12@al
	ld.h	%r6,[%r8]
	ld.w	[%sp+0x1],%r6	; 	xld.w	[%sp+4],%r6
	ext	ppu+0x0@ah	; 	xld.ub	%r10,[ppu]
	ext	ppu+0x0@al
	ld.ub	%r10,[%r8]
	ld.w	%r11,%r10
	and	%r11,0x10	; 	xand	%r11,%r11,0x00000010
	sll	%r11,0x4	; 	xsll	%r11,4
	ld.w	[%sp+0x2],%r11	; 	xld.w	[%sp+8],%r11
	and	%r10,0x3	; 	xand	%r10,%r10,0x00000003
	sll	%r10,0x8	; 	xsll	%r10,10
	sll	%r10,0x2
	ld.w	%r2,%r10
	ext	0x80		; 	xoor	%r2,%r2,0x00002000
	or	%r2,0x0
	ext	ppu+0x4@ah	; 	xld.uh	%r3,[ppu+4]
	ext	ppu+0x4@al
	ld.uh	%r3,[%r8]
	ld.ub	%r4,%r3
	sra	%r3,0x8		; 	xsra	%r3,8
	ext	0x3		; 	xcmp	%r4,239
	cmp	%r4,0x2f
	jrle	__LX87		; 	xjrle	__L87
	ext	0x20		; 	xxor	%r2,%r2,0x00000800
	xor	%r2,0x0
	sub	%r4,0x10	; 	xsub	%r4,%r4,16
__LX87:				; __L87:
	ld.w	%r0,%r3
	sra	%r0,0x3		; 	xsra	%r0,3
	ld.w	%r1,%r4
	sra	%r1,0x3		; 	xsra	%r1,3
	ld.w	%r10,%r3
	and	%r10,0x7	; 	xand	%r10,%r10,0x00000007
	not	%r3,%r10
	add	%r3,1
	ld.w	%r10,%r4
	and	%r10,0x7	; 	xand	%r10,%r10,0x00000007
	not	%r4,%r10
	add	%r4,1
__LX88:				; __L88:
	ld.w	%r10,[%sp+0x0]	; 	xld.w	%r10,[%sp]
	sub	%r10,0x8	; 	xsub	%r10,%r10,8
	cmp	%r4,%r10
	jrle	__LX91		; 	xjrle	__L91
	ext	0x0		; 	xld.w	%r5,0x00000021		; 33
	ld.w	%r5,0x21
	ld.w	%r10,%r1
	and	%r10,0x3c	; 	xand	%r10,%r10,0xfffffffc
	sll	%r10,0x1	; 	xsll	%r10,1
	ext	0xf		; 	xoor	%r10,%r10,0x000003c0
	or	%r10,0x0
	ld.w	[%sp+0x7],%r10	; 	xld.w	[%sp+28],%r10
__LX92:				; __L92:
	ld.w	%r10,%r1
	sll	%r10,0x5	; 	xsll	%r10,5
	ld.w	%r6,%r2
	or	%r6,%r10
	ld.w	%r10,%r6
	or	%r10,%r0
	ld.w	%r6,%r7
	add	%r6,%r10
	ld.w	%r10,%r6
	ld.ub	%r14,[%r10]	; 	xld.ub	%r14,[%r10]
	ld.w	%r10,%r2
	ld.w	%r6,[%sp+0x7]	; 	xld.w	%r6,[%sp+28]
	or	%r10,%r6
	ld.w	%r11,%r0
	sra	%r11,0x2	; 	xsra	%r11,2
	or	%r10,%r11
	ld.w	%r6,%r7
	add	%r6,%r10
	ld.w	%r10,%r6
	ld.ub	%r15,[%r10]	; 	xld.ub	%r15,[%r10]
	ld.w	%r11,%r0
	and	%r11,0x2	; 	xand	%r11,%r11,0x00000002
	ld.w	%r10,%r1
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	sll	%r10,0x1	; 	xsll	%r10,1
	or	%r11,%r10
	ld.w	%r9,%r11	; 	xsra	%r15,%r11
	and	%r9,0x1f
	cmp	%r9,0x8
	jrle	4
	sra	%r15,0x8
	jp.d	-3
	sub	%r9,0x8
	sra	%r15,%r9
	ld.w	%r12,%r3
	ld.w	%r13,%r4
	ld.w	%r6,[%sp+0x2]	; 	xld.w	%r6,[%sp+8]
	or	%r14,%r6
	and	%r15,0x3	; 	xand	%r15,%r15,0x00000003
	ld.w	[%sp+0x3],%r4	; 	xld.w	[%sp+12],%r4
	ld.w	[%sp+0x4],%r5	; 	xld.w	[%sp+16],%r5
	ld.w	[%sp+0x6],%r7	; 	xld.w	[%sp+24],%r7
	ext	ppu_draw_chr@rm	; 	xcall	ppu_draw_chr
	call	ppu_draw_chr@rl
	add	%r3,0x8		; 	xadd	%r3,%r3,8
	add	%r0,0x1		; 	xadd	%r0,%r0,1
	ld.w	%r4,[%sp+0x3]	; 	xld.w	%r4,[%sp+12]
	ld.w	%r5,[%sp+0x4]	; 	xld.w	%r5,[%sp+16]
	ld.w	%r7,[%sp+0x6]	; 	xld.w	%r7,[%sp+24]
	cmp	%r0,0x1f	; 	xcmp	%r0,31
	jrle	__LX94		; 	xjrle	__L94
	sub	%r0,0x20	; 	xsub	%r0,%r0,32
	ext	0x10		; 	xxor	%r2,%r2,0x00000400
	xor	%r2,0x0
__LX94:				; __L94:
	sub	%r5,0x1		; 	xsub	%r5,%r5,1
	jrne	__LX92		; 	xjrne	__L92
	ext	0x4		; 	xsub	%r3,%r3,264
	sub	%r3,0x8
	add	%r0,0x1f	; 	xadd	%r0,%r0,31
	cmp	%r0,0x1f	; 	xcmp	%r0,31
	jrle	__LX91		; 	xjrle	__L91
	sub	%r0,0x20	; 	xsub	%r0,%r0,32
	ext	0x10		; 	xxor	%r2,%r2,0x00000400
	xor	%r2,0x0
__LX91:				; __L91:
	add	%r4,0x8		; 	xadd	%r4,%r4,8
	add	%r1,0x1		; 	xadd	%r1,%r1,1
	cmp	%r1,0x1d	; 	xcmp	%r1,29
	jrle	__LX90		; 	xjrle	__L90
	sub	%r1,0x1e	; 	xsub	%r1,%r1,30
	ext	0x20		; 	xxor	%r2,%r2,0x00000800
	xor	%r2,0x0
__LX90:				; __L90:
	ld.w	%r6,[%sp+0x1]	; 	xld.w	%r6,[%sp+4]
	cmp	%r4,%r6
	jrlt	__LX88		; 	xjrlt	__L88
	add	%sp,0x8		; 	xadd	%sp,%sp,32
	popn	%r3
	ret
	.align	1
	.global	ppu_draw_sprite
ppu_draw_sprite:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ext	ppu+0x0@ah	; 	xbtst	[ppu],0x5
	ext	ppu+0x0@al
	btst	[%r8],0x5
	jreq	__LX101		; 	xjreq	__L101
	call	ppu_draw_sprite_8x16	; 	xcall	ppu_draw_sprite_8x16
	jp	__LX102		; 	xjp	__L102
__LX101:				; __L101:
	call	ppu_draw_sprite_8x8	; 	xcall	ppu_draw_sprite_8x8
__LX102:				; __L102:
	ret
	.align	1
	.global	ppu_draw_sprite_8x8
ppu_draw_sprite_8x8:
;	.frame	%sp,20,$31		# vars= 0, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	ext	ppu_sprram+0xfc@h	; 	xld.w	%r1,ppu_sprram+252
	ext	ppu_sprram+0xfc@m
	ld.w	%r1,ppu_sprram+0xfc@l
	ext	ppu+0x0@ah	; 	xld.ub	%r10,[ppu]
	ext	ppu+0x0@al
	ld.ub	%r10,[%r8]
	and	%r10,0x8	; 	xand	%r10,%r10,0x00000008
	ld.w	%r3,%r10
	sll	%r3,0x5		; 	xsll	%r3,5
	ld.w	%r2,%r12
	sll	%r2,0x5		; 	xsll	%r2,5
	ext	0x1		; 	xld.w	%r0,0x00000040		; 64
	ld.w	%r0,0x0
__LX104:				; __L104:
	ld.w	%r12,[%r1]	; 	xld.w	%r12,[%r1]
	sub	%r1,0x4		; 	xsub	%r1,%r1,4
	ld.ub	%r13,%r12
	sra	%r12,0x8	; 	xsra	%r12,8
	ld.ub	%r14,%r12
	sra	%r12,0x8	; 	xsra	%r12,8
	ld.ub	%r11,%r12
	sra	%r12,0x8	; 	xsra	%r12,8
	ld.ub	%r12,%r12
	ld.w	%r10,%r11
	xor	%r10,%r2
	ext	0x0		; 	xand	%r10,%r10,0x00000020
	and	%r10,0x20
	jrne	__LX106		; 	xjrne	__L106
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	or	%r14,%r3
	ld.w	%r10,%r11
	and	%r10,0x3	; 	xand	%r10,%r10,0x00000003
	ld.w	%r15,%r10
	or	%r15,0x4	; 	xoor	%r15,%r15,0x00000004
	ld.w	%r10,%r11
	sra	%r10,0x6	; 	xsra	%r10,6
	cmp	%r10,0x2	; 	xcmp	%r10,2
	jreq	__LX111		; 	xjreq	__L111
	jrgt	__LX114		; 	xjrgt	__L114
	cmp	%r10,0x1	; 	xcmp	%r10,1
	jreq	__LX110		; 	xjreq	__L110
	jp	__LX109		; 	xjp	__L109
__LX114:				; __L114:
	cmp	%r10,0x3	; 	xcmp	%r10,3
	jreq	__LX112		; 	xjreq	__L112
__LX109:				; __L109:
	ext	ppu_draw_chr@rm	; 	xcall	ppu_draw_chr
	call	ppu_draw_chr@rl
	jp	__LX106		; 	xjp	__L106
__LX110:				; __L110:
	ext	ppu_draw_chr_revx@rm	; 	xcall	ppu_draw_chr_revx
	call	ppu_draw_chr_revx@rl
	jp	__LX106		; 	xjp	__L106
__LX111:				; __L111:
	ext	ppu_draw_chr_revy@rm	; 	xcall	ppu_draw_chr_revy
	call	ppu_draw_chr_revy@rl
	jp	__LX106		; 	xjp	__L106
__LX112:				; __L112:
	ext	ppu_draw_chr_revxy@rm	; 	xcall	ppu_draw_chr_revxy
	call	ppu_draw_chr_revxy@rl
__LX106:				; __L106:
	sub	%r0,0x1		; 	xsub	%r0,%r0,1
	jrne	__LX104		; 	xjrne	__L104
	popn	%r3
	ret
	.align	1
	.global	ppu_draw_sprite_8x16
ppu_draw_sprite_8x16:
;	.frame	%sp,32,$31		# vars= 12, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x3		; 	xsub	%sp,%sp,12
	ext	ppu_sprram+0xfc@h	; 	xld.w	%r4,ppu_sprram+252
	ext	ppu_sprram+0xfc@m
	ld.w	%r4,ppu_sprram+0xfc@l
	ld.w	[%sp+0x1],%r4	; 	xld.w	[%sp+4],%r4
	sll	%r12,0x5	; 	xsll	%r12,5
	ld.w	[%sp+0x0],%r12	; 	xld.w	[%sp],%r12
	ext	0x1		; 	xld.w	%r4,0x00000040		; 64
	ld.w	%r4,0x0
	ld.w	[%sp+0x2],%r4	; 	xld.w	[%sp+8],%r4
__LX117:				; __L117:
	ld.w	%r4,[%sp+0x1]	; 	xld.w	%r4,[%sp+4]
	ld.w	%r0,[%r4]	; 	xld.w	%r0,[%r4]
	sub	%r4,0x4		; 	xsub	%r4,%r4,4
	ld.w	[%sp+0x1],%r4	; 	xld.w	[%sp+4],%r4
	ld.ub	%r2,%r0
	sra	%r0,0x8		; 	xsra	%r0,8
	ld.ub	%r1,%r0
	sra	%r0,0x8		; 	xsra	%r0,8
	ld.ub	%r12,%r0
	sra	%r0,0x8		; 	xsra	%r0,8
	ld.ub	%r0,%r0
	ld.w	%r10,%r12
	ld.w	%r4,[%sp+0x0]	; 	xld.w	%r4,[%sp]
	xor	%r10,%r4
	ext	0x0		; 	xand	%r10,%r10,0x00000020
	and	%r10,0x20
	jrne	__LX119		; 	xjrne	__L119
	add	%r2,0x1		; 	xadd	%r2,%r2,1
	ld.w	%r10,%r1
	and	%r10,0x3e	; 	xand	%r10,%r10,0xfffffffe
	ld.w	%r11,%r1
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	sll	%r11,0x8	; 	xsll	%r11,8
	ld.w	%r1,%r10
	or	%r1,%r11
	ld.w	%r10,%r12
	and	%r10,0x3	; 	xand	%r10,%r10,0x00000003
	ld.w	%r3,%r10
	or	%r3,0x4		; 	xoor	%r3,%r3,0x00000004
	ld.w	%r10,%r12
	sra	%r10,0x6	; 	xsra	%r10,6
	cmp	%r10,0x2	; 	xcmp	%r10,2
	jreq	__LX124		; 	xjreq	__L124
	jrgt	__LX127		; 	xjrgt	__L127
	cmp	%r10,0x1	; 	xcmp	%r10,1
	jreq	__LX123		; 	xjreq	__L123
	jp	__LX122		; 	xjp	__L122
__LX127:				; __L127:
	cmp	%r10,0x3	; 	xcmp	%r10,3
	jreq	__LX125		; 	xjreq	__L125
__LX122:				; __L122:
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ld.w	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr@rm	; 	xcall	ppu_draw_chr
	call	ppu_draw_chr@rl
	ld.w	%r12,%r0
	ext	0x8		; 	xadd	%r13,%r2,8
	add	%r13,%r2
	ext	0x1		; 	xadd	%r14,%r1,1
	add	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr@rm	; 	xcall	ppu_draw_chr
	call	ppu_draw_chr@rl
	jp	__LX119		; 	xjp	__L119
__LX123:				; __L123:
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ld.w	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revx@rm	; 	xcall	ppu_draw_chr_revx
	call	ppu_draw_chr_revx@rl
	ld.w	%r12,%r0
	ext	0x8		; 	xadd	%r13,%r2,8
	add	%r13,%r2
	ext	0x1		; 	xadd	%r14,%r1,1
	add	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revx@rm	; 	xcall	ppu_draw_chr_revx
	call	ppu_draw_chr_revx@rl
	jp	__LX119		; 	xjp	__L119
__LX124:				; __L124:
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ext	0x1		; 	xadd	%r14,%r1,1
	add	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revy@rm	; 	xcall	ppu_draw_chr_revy
	call	ppu_draw_chr_revy@rl
	ld.w	%r12,%r0
	ext	0x8		; 	xadd	%r13,%r2,8
	add	%r13,%r2
	ld.w	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revy@rm	; 	xcall	ppu_draw_chr_revy
	call	ppu_draw_chr_revy@rl
	jp	__LX119		; 	xjp	__L119
__LX125:				; __L125:
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ext	0x1		; 	xadd	%r14,%r1,1
	add	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revxy@rm	; 	xcall	ppu_draw_chr_revxy
	call	ppu_draw_chr_revxy@rl
	ld.w	%r12,%r0
	ext	0x8		; 	xadd	%r13,%r2,8
	add	%r13,%r2
	ld.w	%r14,%r1
	ld.w	%r15,%r3
	ext	ppu_draw_chr_revxy@rm	; 	xcall	ppu_draw_chr_revxy
	call	ppu_draw_chr_revxy@rl
__LX119:				; __L119:
	ld.w	%r4,[%sp+0x2]	; 	xld.w	%r4,[%sp+8]
	sub	%r4,0x1		; 	xsub	%r4,%r4,1
	ld.w	[%sp+0x2],%r4	; 	xld.w	[%sp+8],%r4
	jrne	__LX117		; 	xjrne	__L117
	add	%sp,0x3		; 	xadd	%sp,%sp,12
	popn	%r3
	ret

	.comm	ppu 52

	.comm	ppu_vram 16384

	.comm	ppu_sprram 256
