/*	
 *	framppu.c
 *
 *	P/ECE PPU (RICOH RP2C02) Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2005 Naoyuki Sawa
 *
 *	* Sun Jan 30 21:25:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clip.h"

/****************************************************************************
 *
 ****************************************************************************/

#define PPU_DRAW_CHR_IMPLEMENT
//
#define PPU_REVX 0
#define PPU_REVY 0
void ppu_draw_chr(int xpos, int ypos, int code, int palno)
#include "clipppui.h"
#undef PPU_REVX
#undef PPU_REVY
//
#define PPU_REVX 1
#define PPU_REVY 0
void ppu_draw_chr_revx(int xpos, int ypos, int code, int palno)
#include "clipppui.h"
#undef PPU_REVX
#undef PPU_REVY
//
#define PPU_REVX 0
#define PPU_REVY 1
void ppu_draw_chr_revy(int xpos, int ypos, int code, int palno)
#include "clipppui.h"
#undef PPU_REVX
#undef PPU_REVY
//
#define PPU_REVX 1
#define PPU_REVY 1
void ppu_draw_chr_revxy(int xpos, int ypos, int code, int palno)
#include "clipppui.h"
#undef PPU_REVX
#undef PPU_REVY
//
#undef PPU_DRAW_CHR_IMPLEMENT

/****************************************************************************
 *
 ****************************************************************************/

